=== debian/changelog ===
plplot (5.10.0+dfsg2-0.4ubuntu1) zesty; urgency=medium

  * Merge from Debian unstable.  Remaining changes:
    - Honour nocheck in DEB_BUILD_OPTIONS.
    - Enable verbose builds and tests.
    - Remove multiarch path in pkgconfig files.

 -- Bhavani Shankar <bhavi@ubuntu.com>  Mon, 09 Jan 2017 08:53:58 +0530

plplot (5.10.0+dfsg2-0.4) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with cmake >= 3.6.2. Closes: #835708

 -- Ole Streicher <olebole@debian.org>  Tue, 20 Sep 2016 09:12:35 +0200

plplot (5.10.0+dfsg2-0.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with "dpkg-buildpackage -A" by letting build-indep-stamp
    depend on config-stamp in debian/rules. (Closes: #816987)

 -- Axel Beckert <abe@debian.org>  Wed, 03 Aug 2016 21:18:45 +0200

plplot (5.10.0+dfsg2-0.2ubuntu1) yakkety; urgency=medium

  * Merge with Debian; remaining changes:
    - Honor nocheck in DEB_BUILD_OPTIONS.
    - Enable verbose builds and tests.
    - Remove multiarch path in pkgconfig files.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 06 May 2016 20:38:36 +0200

plplot (5.10.0+dfsg2-0.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Switch enabling/disabling of D and Octave support to slice +
    debian/control.in instead of commenting. Allow to disable ADA support
    completely (not only for sh4) that way, too.
  * Disable ADA and D support which currently FTBFS. (Closes: #809592)
  * Update debian/control from debian/control.in with "debian/rules
    control".
  * Replace out-dated debian/README.source with according instructions.

 -- Axel Beckert <abe@debian.org>  Tue, 16 Feb 2016 22:32:30 +0100

plplot (5.10.0+dfsg2-0.1ubuntu2) xenial; urgency=medium

  * Rebuild for ocaml ABI changes.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 17 Feb 2016 13:20:22 +0100

plplot (5.10.0+dfsg2-0.1ubuntu1) xenial; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Honor nocheck in DEB_BUILD_OPTIONS.
    - Enable verbose builds and tests.
    - Remove multiarch path in pkgconfig files.
  * Dropped changes, included in Debian:
    - Apply work-arounds from Debian #789619 to fix the ftbfs.
  * Dropped changes:
    - debian/libplplot-lua.files: don't diverge from Debian, we stopped trying
      to build against lua5.2 in vivid (why?) so don't need to carry a delta
      just to match on non-lua5.1 files.
    - drop disabling of octave tests, which shouldn't run when the octave
      frontend isn't configured.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 01 Nov 2015 15:29:48 -0800

plplot (5.10.0+dfsg2-0.1) unstable; urgency=low

  [ Axel Beckert ]
  * Non-maintainer upload.
  * Repack upstream tarball to no more include non-free image lena.*.
    + Add patch to remove handling of lena images from multiple files.
    + Add according Files-Excluded header to debian/copyright.
    + Fixes lintian-reported error license-problem-non-free-img-lenna.
    + Closes: #794857
  * debian/copyright: Add missing path element in URL in Source field.
    Issue found by DUCK.
  * Add build-dependency on dh-python to fix FTBFS in
    bindings/python/CMakeFiles/plplot_widgetmodule.dir/plplot_widgetmodule.c.o.

  [ Peter Michael Green ]
  * Apply upstream patch to fix build with cmake 3.1 (Closes: #789619)
  * Disable octave support as it's currently broken
    + see my post to bug #789619 for further info on the error
    + debian/rules and debian/control changes adapted from 5.10.0-0ubuntu5
      package by Matthias Klose
    + also moved liboctave-dev build-depends to build-conflicts as
      upstream buildsystem was trying to build octave stuff even without
      debian/rules telling it to.
  * Add tcl8.6 and tk8.6 to build-conflicts, having multiple versions of
    tcl/tk arround seems to break the build.

 -- Axel Beckert <abe@debian.org>  Wed, 14 Oct 2015 17:17:48 +0200
